# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import keyvalues
import popuplib
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# * VARIABLES

db     = 'sam_admins'
dbfile = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db
access = [
		'Admins Manager',
		'Addons Manager',
		'Kick',
		'Ban Level 1',
		'Ban Level 2',
		'Unban',
		'Move Players',
		'Slay',
		'Mute',
		'Server Commands',
		'Remote RCON',
		'Advance Control',
		'Admin Chat',
		'Votes'
		]
adv    = ['Respawn','Noclip','Godmode','Freeze','Jetpack','Blind','Firework','Slap','Set Health','Give Cash','Invisibility']

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Temp Vars ###
	es.set('sam_first_admin', 0)

	### Load Keygroups ###
	if checkDB(): es.keygroupload(db, func.dbfiles)

	### Load Groups ###
	es.load('sam/admins/groups')
	groups = es.import_addon('sam/admins/groups')

	### CMDS ###
	cmdlib.registerSayCommand('!addadmin', addAdminCMD, 'SAM')
	cmdlib.registerClientCommand('sam_addadmin', addAdminCMD, 'SAM')

	### Update Admins ###
	if checkDB():
		for ply in playerlib.getPlayerList('#human'):
			if isAdmin(ply.steamid): update(ply.steamid)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Deletes ###
	es.keygroupdelete(db)

	### CMDS ###
	cmdlib.unregisterSayCommand('!addadmin')
	cmdlib.unregisterClientCommand('sam_addadmin')

	### Unload Groups ###
	es.unload('sam/admins/groups')

	### Popups ###
	func.popupDelete('firstAdmin')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def addAdminCMD(userid, args):
	if isAdmin(es.getplayersteamid(userid)):
		if checkAccess(es.getplayersteamid(userid), 'Admins Manager'):
			if args:
				string = ''.join(args)
				if string.startswith('STEAM_'):
					if not isAdmin(string):
						add(string)
						block = es.import_addon('sam/base/manager')
						block.editChoice(userid, string, None)
					else: func.hudhint(userid, func.lang_admins('is_admin', {'admin':string}), func.admins_hudtag)
				elif es.exists('userid', es.getuserid(string)):
					target = es.getplayersteamid(es.getuserid(string))
					if not isAdmin(target):
						add(target)
						block = es.import_addon('sam/base/manager')
						block.editChoice(userid, target, None)
					else: func.hudhint(userid, func.lang_admins('is_admin', {'admin':es.getplayername(es.getuserid(string))}), func.admins_hudtag)
			else:
				block = es.import_addon('sam/base/manager')
				block.managerChoice(userid, 1, None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def isAdmin(target):
	if checkDB():
		if es.exists('keygroup', db):
			if es.exists('key', db, target): return True
			else: return False
		else: return False
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getAdmin(target):
	if isAdmin(target):
		tokens = {'steamid':target}
		for List in (('immunity','name','group'),access):
			for item in List: tokens[item] = es.keygetvalue(db, target, item)
		return tokens
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def add(target, state='no'):
	string = str(target)
	if string.startswith('STEAM_'): admin = {'steamid':string,'name':string}
	else:
		target = playerlib.getPlayer(es.getuserid(target))
		admin  = {'steamid':target.steamid,'name':target.name}
	if not es.exists('keygroup', db): es.keygroupcreate(db)
	es.keycreate(db, admin['steamid'])
	es.keysetvalue(db, admin['steamid'], 'name', admin['name'])
	es.keysetvalue(db, admin['steamid'], 'immunity', 0)
	es.keysetvalue(db, admin['steamid'], 'group', 'None')
	for item in access: es.keysetvalue(db, admin['steamid'], item, state)
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def remove(userid, target):
	if isAdmin(target):
		if len(list(keyvalues.getKeyGroup(db))) > 1:
			es.keydelete(db, target)
			es.keygroupsave(db, func.dbfiles)
		else: func.hudhint(userid, func.lang_admins('need_one_admin'), func.admins_hudtag)
	else: func.hudhint(userid, func.lang_admins('not_admin'), func.admins_hudtag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def update(admin):
	admin = playerlib.getPlayer(es.getuserid(admin))
	es.keysetvalue(db, admin.steamid, 'name', admin.name)
	for item in access:
		if not es.exists('keyvalue', db, admin.steamid, item): es.keysetvalue(db, admin.steamid, item, 'yes')
	es.keygroupsave(db, func.dbfiles)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkAccess(target, item):
	if item in adv: item = 'Advance Control'
	admin = getAdmin(target)
	if admin['group'] != 'None':
		groups = es.import_addon('sam/admins/groups')
		group  = groups.get(admin['group'])
	else:
		if item == 'Ban': group = {'Ban Level 1':'None','Ban Level 1':'None'}
		else: group = {item:'None'}
	if item == 'Ban':
		if admin['Ban Level 1'] == 'yes' or admin['Ban Level 2'] == 'yes' or group['Ban Level 2'] == 'yes' or group['Ban Level 2'] == 'yes': return True
		else:
			func.hudhint(es.getuserid(admin['steamid']), func.lang_admins('no_access'), func.admins_hudtag)
			return False
	elif admin[item] == 'yes' or group[item] == 'yes': return True
	else:
		func.hudhint(es.getuserid(admin['steamid']), func.lang_admins('no_access'), func.admins_hudtag)
		return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkImmunity(admin, target, notify=1):
	if isAdmin(target) and admin != target:
		groups = es.import_addon('sam/admins/groups')
		admin  = getAdmin(admin)
		target = getAdmin(target)
		### Admin IM
		if admin['group'] != 'None':
			group = groups.get(admin['group'])
			if int(group['immunity']) > int(admin['immunity']): adminIM = int(group['immunity'])
			else: adminIM = int(admin['immunity'])
		else: adminIM = int(admin['immunity'])
		### Target IM
		if target['group'] != 'None':
			group = groups.get(target['group'])
			if int(group['immunity']) > target['immunity']: targetIM = int(group['immunity'])
			else: targetIM = target['immunity']
		else: targetIM = target['immunity']
		### Algorithm
		if adminIM > targetIM: return True
		elif adminIM <= targetIM:
			if notify == 1: func.hudhint(es.getuserid(admin['steamid']), func.lang_admins('low_immunity'), func.admins_hudtag)
			return False
	else: return True

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def checkDB():
	if not os.path.isfile(dbfile) == True:
		es.set('sam_first_admin', 1)
		return False
	else: return True

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if checkDB(): update(ev['es_steamid'])

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_changename(ev):
	if checkDB(): update(ev['es_steamid'])

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def firstAdmin(userid):
	target = playerlib.getPlayer(userid)
	func.popupDelete('firstAdmin')
	popup = popuplib.create('firstAdmin')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.addline('\n \n :: %s' % func.lang_titles('manager_name'))
	popup.addline(func.pline + '-' * 15)
	popup.addline(' %s\n' % func.lang_admins('firstAdmin_line1'))
	popup.addline(' %s\n \n' % func.lang_admins('firstAdmin_line2'))
	popup.addline(func.lang_admins('firstAdmin_line3'))
	popup.addline('->1. %s' % func.lang_word('yes'))
	popup.addline('->2. %s' % func.lang_word('no'))
	popup.addline(' ')
	popup.addline(func.pline + '-' * 15)
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.menuselect = firstPageSelect
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def firstPageSelect(userid, choice, popup):
	if choice == 1:
		es.set('sayfilter_%s' % (userid), 1)
		es.addons.registerSayFilter(chatFilter)
		func.tell(userid, '#grey%s' % func.lang_admins('rcon_confirmation'), func.adminstag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def chatFilter(userid, text, teamonly):
	var = es.ServerVar('sayfilter_%s' % (userid))
	if int(var) == 1:
		text = text.strip('"')
		var.set(0)
		if str(text) == es.ServerVar('rcon_password'):
			add(userid, 'yes')
			block = es.import_addon('sam/base')
			block.displayMenu(userid)
			block = es.import_addon('sam/base/manager')
			block.modulePopup(userid)
			es.set('sam_first_admin', 0)
			block.editChoice(userid, es.getplayersteamid(userid), None)
		else: func.tell(userid, '#grey%s' % func.lang_admins('invalid_rcon', {'text':str(text)}), func.servertag)
		es.addons.unregisterSayFilter(chatFilter)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================= #