# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import popuplib
import playerlib
# ============================================================================================================================================================= #

# * ADMINS LOAD
es.load('sam/admins')

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

bases = ['manager','pcontrol','addons'] 

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Modules ###
	for item in bases: es.load('sam/base/%s' % item)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unloads ###
	for item in bases: es.unload('sam/base/%s' % item)
	es.unload('sam/admins')

	### Popups ###
	func.popupDelete('mainPage')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def menuCMD(userid = None):
	if userid == None: userid = es.getcmduserid()
	if admins.checkDB():
		if admins.isAdmin(es.getplayersteamid(userid)): displayMenu(userid)
		else: func.hudhint(userid, func.lang_admins('no_access'), func.admins_hudtag)
	else: admins.firstAdmin(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def displayMenu(userid):
	func.popupDelete('mainPage')
	popup = popuplib.easymenu('mainPage', None, mainPageChoice)
	popup.c_beginsep = func.pline
	if not func.outdated == 0 and not func.outdated == None:
		popup.c_pagesep = '%s\nUPDATE SYSTEM:\n%s\n%s' % (func.pline,func.lang_base('is_outdated2', {'newversion':func.outdated}).upper(),func.pline)
	else: popup.c_pagesep = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: %s' % func.lang_titles('base_mainPage_title'))
	popup.addoption('pcontrol', func.lang_titles('pcontrol_name'))
	popup.addoption('mapchange', func.lang_titles('addons_mapchange_name'))
	popup.addoption('addons', func.lang_titles('addons_name'))
	popup.addoption('manager', func.lang_titles('manager_name'))
	if int(es.ServerVar('sam_first_admin')) == 0: popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def mainPageChoice(userid, choice, popup):
	if choice in bases:
		block = es.import_addon('sam/base/%s' % (choice))
		if choice == 'pcontrol': block.modulePopup(userid)
		elif choice == 'addons':
			if admins.checkAccess(es.getplayersteamid(userid), 'Addons Manager'): block.modulePopup(userid)
			else: displayMenu(userid)
		elif choice == 'manager':
			if admins.checkAccess(es.getplayersteamid(userid), 'Admins Manager'): block.modulePopup(userid)
			else: displayMenu(userid)
	else:
		if es.ServerVar('sam_%s' % choice) == 1:
			block = es.import_addon('sam/base/addons/%s' % choice)
			block.modulePopup(userid)
		else:
			func.hudhint(userid, func.lang_addons('addon_is_disabled', {'addon':es.keygetvalue('addons_db', choice, 'name')}))
			displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def changelog(userid, choice, popup): func.motd(userid, 'http://addons.eventscripts.com/addons/view/sam', 'Version %s Changelog' % func.outdated)

# ============================================================================================================================================================= #