# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import os
import playerlib
import popuplib
import time
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func     = es.import_addon('sam/functions')
admins   = es.import_addon('sam/admins')
pcontrol = es.import_addon('sam/base/pcontrol')

# * VARIABLES

# Temp Dict
temp = {}

# Keygroups
db     = 'sam_banlist'
db_dir = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db

# Ban Levels
level1 = {
		 'b5 Minutes':300,
		 'c30 Minutes':1800,
		 'd1 Hour':3600,
		 'e3 Hours':10800,
		 'f1 Day':86400
		 }
level2 = {
		 'g3 Days':259200,
		 'h1 Week':604800,
		 'i1 Month':2592000,
		 'j1 Year':31536000,
		 'aperm':'perm'
		 }

bantag = '#greenBAN'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Keygroups ###
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.dbfiles)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unload Keygroups ###
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	### Popups ###
	func.popupDelete('getTime')
	func.popupDelete('getReason')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(admin, target):
	if admins.checkImmunity(admin.steamid, target.steamid):
		temp[target.steamid] = {}
		temp[target.steamid]['name']      = target.name
		temp[target.steamid]['adminname'] = admin.name

		# TEMP LIST
		templist = []
		for x in (level1,level2):
			for item in x: templist.append(item)
		templist.sort()

		func.popupDelete('getTime')
		popup = popuplib.easymenu('getTime', None, banChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: ' + func.lang_titles('pcontrol_getTime_desc', {'func':func.lang_titles('pcontrol_ban')}))
		for item in templist: popup.addoption({'steamid':target.steamid, 'choice':item}, func.lang_pcontrol(item.replace(item[0], '')))
		popup.submenu(10, 'pcontrol')
		popup.send(admin)
	else: pcontrol.function(admin, 'Ban', None)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def banChoice(userid, choice, popup):
	steamid = choice['steamid']
	length  = choice['choice']
	temp[steamid]['length'] = length.replace(length[0], '')

	if not length == 'aperm':
		if length in level1: temp[steamid]['banid'] = int(time.time()) + level1[length]
		elif length in level2: temp[steamid]['banid'] = int(time.time()) + level2[length]
	else: temp[steamid]['banid'] = 'perm'

	func.popupDelete('getReason')
	popup = popuplib.easymenu('getReason', None, banTarget)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + func.lang_titles('pcontrol_getBanReason_desc'))
	_list = getReasons()
	for x in _list: popup.addoption({'steamid':steamid, 'choice':x.strip()}, x.strip())
	popup.submenu(10, 'pcontrol')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def banTarget(userid, choice, popup):
	target                 = choice['steamid']
	temp[target]['reason'] = choice['choice']
	if es.exists('keygroup', db) == 0: es.keygroupcreate(db)
	if es.exists('key', db, target) == 0: es.keycreate(db, target)
	for item in temp[target]: es.keysetvalue(db, target, item.lower(), temp[target][item])
	es.keygroupsave(db, func.dbfiles)
	del temp[target]
	pcontrol.function(userid, 'Ban', None)

	if es.exists('userid', es.getuserid(target)):
		target = playerlib.getPlayer(es.getuserid(target))
		target.kick(reason=func.lang_pcontrol('ban_banned_msg', getBanned(target.steamid)))
		func.tell('#human', func.lang_pcontrol('ban_banned_announce', getBanned(target.steamid)), bantag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def isBanned(target):
	if es.exists('key', db, target):
		if es.keygetvalue(db, target, 'banid') == 'perm': return True
		elif int(es.keygetvalue(db, target, 'banid')) > int(time.time()): return True
		else:
			es.keydelete(db, target)
			es.keygroupsave(db, func.dbfiles)
			return False
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getBanned(target):
	return {'name':es.keygetvalue(db, target, 'name'),'admin':es.keygetvalue(db, target, 'adminname'),
		    'banid':es.keygetvalue(db, target, 'banid'),'reason':es.keygetvalue(db, target, 'reason'),
		    'steamid':target,'length':es.keygetvalue(db, target, 'length')}

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if isBanned(ev['es_steamid']):
		target = playerlib.getPlayer(ev['userid'])
		target.kick(reason=func.lang_pcontrol('ban_banned_msg', getBanned(target.steamid)))

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def getReasons():
	es.load('sam/functions/cfg')
	_list = []
	with open('cstrike/cfg/sam/reasons.txt') as f:
		for line in f.readlines():
			if line.startswith('-') or line.startswith('- '): _list.append(line.replace('- ', '').replace('-', ''))
	return _list

# ============================================================================================================================================================= #