# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import popuplib
import cmdlib
import usermsg
import random
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

movep_tag = '#green%s' % func.lang_word('teams').upper()

teams = {
		1:'#spec%s' % func.lang_word('spec'),
		2:'#red%s' % func.lang_word('t'),
		3:'#blue%s' % func.lang_word('ct')
		}

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Popups ###	
	func.popupDelete('teamChange')
	func.popupDelete('oppositeteams')
	func.popupDelete('moveTospectator')
	func.popupDelete('moveToteams')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	func.popupDelete('teamChange')
	popup = popuplib.create('teamChange')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
	popup.addline('\n \n :: %s' % func.lang_titles('pcontrol_moveplayers'))
	popup.addline(func.pline)
	popup.addline('->1. %s' % func.lang_word('spec'))
	popup.addline('->2. %s' % func.lang_word('t'))
	popup.addline('->3. %s' % func.lang_word('ct'))
	popup.addline('->4. %s' % func.lang_pcontrol('movep_opposite_team'))
	popup.addline('->5. %s' % func.lang_pcontrol('movep_switch'))
	popup.addline('->6. %s' % func.lang_pcontrol('movep_allspec'))
	popup.addline(' ')
	popup.addline(func.pline)
	popup.addline('->8. %s' % func.lang_word('back'))
	popup.addline('->0. %s' % func.lang_word('cancel'))
	popup.select(1, moveTospectator)
	popup.select(2, moveToteams)
	popup.select(3, moveToteams)
	popup.select(4, oppositeTeam)
	popup.select(5, switchTeams)
	popup.select(6, allSpec)
	popup.menuselect = teamChangeChoice
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def teamChangeChoice(userid, choice, popup):
	if choice in range(5,8) or choice == 9: moduleAction(userid)
	elif choice == 8:
		block = es.import_addon('sam/base/pcontrol')
		block.modulePopup(userid)
	elif choice == 10: func.popupDelete(popup)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def moveTospectator(userid, choice, popup):
	alive = playerlib.getPlayerList('#alive')

	if len(alive) > 0:
		func.popupDelete('moveTospectator')
		popup = popuplib.easymenu('moveTospectator', None, moveTospectatorChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s' % func.lang_titles('pcontrol_moveplayers_desc'))
		for player in playerlib.getPlayerList('#alive'): popup.addoption(player, player.name)
		popup.submenu(10, 'teamChange')
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_pcontrol('empty_teams'))
		moduleAction(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def moveTospectatorChoice(userid, choice, popup):
	es.server.insertcmd('es_xchangeteam %s 1' % (choice))
	moduleAction(userid)
	func.tell('#all', func.lang_pcontrol('movep_player_moved', {'target':choice.name,'team':teams[1]}), movep_tag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def moveToteams(userid, choice, popup):
	spec = playerlib.getPlayerList('#spec')
	ct   = playerlib.getPlayerList('#ct')
	t    = playerlib.getPlayerList('#t')
	if choice == 2: total = len(ct) + len(spec)
	elif choice == 3: total = len(t) + len(spec)
	
	if total > 0:
		func.popupDelete('moveToteams')
		popup = popuplib.easymenu('moveToteams', None, moveToteamsChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s' % func.lang_titles('pcontrol_moveplayers_desc'))
		for ply in playerlib.getPlayerList('#spec'): popup.addoption({'target':ply,'id':choice}, '%s [SPEC]' % ply.name)
		if choice == 2:
			for ply in ct: popup.addoption({'target':ply,'id':choice}, '%s [CT]' % ply.name)
		elif choice == 3:
			for ply in t: popup.addoption({'target':ply,'id':choice}, '%s [T]' % ply.name)
		popup.submenu(10, 'teamChange')
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_pcontrol('empty_teams'))
		moduleAction(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def moveToteamsChoice(userid, choice, popup):
	target  = playerlib.getPlayer(choice['target'])
	es.server.insertcmd('es_xchangeteam %s %s' % (target,choice['id']))
	moduleAction(userid)
	func.tell('#all', func.lang_pcontrol('movep_player_moved', {'target':target.name,'team':teams[int(choice['id'])]}), movep_tag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def oppositeTeam(userid, choice, popup):
	alive = playerlib.getPlayerList('#alive')
	if len(alive) > 0:
		func.popupDelete('oppositeTeams')
		popup = popuplib.easymenu('oppositeTeams', None, oppositeTeamsChoice)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s' % (func.menutitle, es.ServerVar('sam_version')))
		popup.setdescription('\n \n :: %s' % func.lang_titles('pcontrol_moveplayers_desc'))
		for player in alive:
			if player.teamid == 2: popup.addoption(player, '%s [T]' % (player.name))
			elif player.teamid == 3: popup.addoption(player, '%s [CT]' % (player.name))
		popup.submenu(10, 'teamChange')
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_pcontrol('empty_teams'))
		moduleAction(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def oppositeTeamsChoice(userid, choice, popup):
	if int(choice.teamid) == 2:
		num = 3
		es.server.insertcmd('es_xchangeteam %s 3' % (choice))
	elif int(choice.teamid) == 3:
		num = 2
		es.server.insertcmd('es_xchangeteam %s 2' % (choice))
	moduleAction(userid)
	func.tell('#all', func.lang_pcontrol('movep_player_moved', {'target':choice.name,'team':teams[num]}), movep_tag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def switchTeams(userid, choice, popup):
	if len(playerlib.getPlayerList('#alive')) > 0:
		ct = playerlib.getPlayerList('#ct')
		t  = playerlib.getPlayerList('#t')
		for ply in ct: es.server.insertcmd('es_xchangeteam %s 2' % ply)
		for ply in t: es.server.insertcmd('es_xchangeteam %s 3' % ply)
		func.tell('#all', func.lang_pcontrol('movep_teams_switched'), movep_tag)
	else: func.hudhint(userid, func.lang_pcontrol('empty_teams'))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def allSpec(userid, choice, popup):
	if len(playerlib.getPlayerList('#alive')) > 0:
		for ply in playerlib.getPlayerList('#alive'): es.server.insertcmd('es_xchangeteam %s 1' % (ply.userid))
		func.tell('#all', func.lang_pcontrol('movep_moved_allspec'), movep_tag)
	else: func.hudhint(userid, func.lang_pcontrol('empty_teams'))

# ============================================================================================================================================================= #