# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import re
import os
import popuplib
import usermsg
import playerlib
import langlib
import cmdlib
import esamlib
# ============================================================================================================================================================= #

# '''''''''''''''''''' # Lang Strings # '''''''''''''''''''' #
langs      = {'english':'en', 'portuguese':'pt'}
langDir    = es.getAddonPath('sam') + '/langs/'
word       = langlib.Strings(langDir + 'words.ini')
titles     = langlib.Strings(langDir + 'titles.ini')
admins     = langlib.Strings(langDir + 'admins/admins_base.ini')
groups     = langlib.Strings(langDir + 'admins/groups_base.ini')
addons     = langlib.Strings(langDir + 'addons/addons_base.ini')
base       = langlib.Strings(langDir + 'base.ini')
addonsDesc = langlib.Strings(langDir + 'addons/addons_descs.ini')
manager    = langlib.Strings(langDir + 'manager/manager_base.ini')
pcontrol   = langlib.Strings(langDir + 'pcontrol/pcontrol_base.ini')
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES * #

# ''''''''''''''''''''''' # COMMON # ''''''''''''''''''''''' #
menutitle  = 'Source Admin Menu'
tag        = '#redSAM'
dbfiles    = 'sam/databases'
lang       = 'english'
pline      = '-' * 47
outdated   = 0
colorspath = 'cstrike/cfg/sam/colors.txt'
dev        = 0

servertag     = '#yellow' + titles('server_tag', None, langs[lang]).upper()
adminstag     = '#cyan'   + titles('admins_tag', None, langs[lang]).upper()
admins_hudtag =             titles('admins_tag', None, langs[lang]).upper()
server_hudtag =             titles('server_tag', None, langs[lang]).upper()
errortag      = word('error', None, langs[lang]).upper()
updatetag     = '#purpleUPDATE SYSTEM'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

filters = ('#all','#human','#ct','#t','#spec','#alive','#dead')

# * POPUPS
popupCloud = []

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Language ###
	cmdlib.registerServerCommand('sam_language', langCMD, 'SAM')

	### Main menu CMD ###
	regsay('sam_menu_saycmd', '!sam', 'sam/base/menuCMD')
	regclient('sam_menu_clientcmd', 'sam_menu', 'sam/base/menuCMD')

	### Menu Title ###
	cmdlib.registerServerCommand('sam_menu_title', tittleCMD, 'SAM')

	### Chat Tag ###
	cmdlib.registerServerCommand('sam_chat_tag', tagCMD, 'SAM')

	### Remote RCON ###
	unreg('!rcon')
	cmdlib.registerSayCommand('!rcon', RRCONcheckCMD, 'SAM')
	cmdlib.registerClientCommand('sam_rcon', RRCONcheckCMD, 'SAM')
	cmdlib.registerServerCommand('sam_rrcon', RRCONserverCMD, 'SAM')

	### Console Variables Status ###
	regsay('sam_check_alltalk', '!alltalk', 'sam/functions/check_alltalkCMD')
	regsay('sam_check_ff', '!ff', 'sam/functions/check_ffCMD')

	### Admins Online ###
	regsay('sam_admins_online', '!admins', 'sam/functions/adminsOnlineCMD')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### func Unreg CMDs ###
	unreg('sam_menu_clientcmd')
	unreg('sam_menu_saycmd')
	unreg('sam_check_alltalk')
	unreg('sam_check_ff')
	unreg('sam_admins_online')
	unreg('sam_remote_rcon_say')
	unreg('sam_remote_rcon_client')

	### Unreg CMDs ###
	cmdlib.unregisterSayCommand('!rcon')
	cmdlib.unregisterClientCommand('sam_rcon')
	cmdlib.unregisterServerCommand('sam_language')
	cmdlib.unregisterServerCommand('sam_menu_title')
	cmdlib.unregisterServerCommand('sam_chat_tag')
	cmdlib.unregisterServerCommand('sam_rrcon')

	### Popups Delete ###
	for name in popupCloud: popupDelete(name)

# ============================================================================================================================================================= #
# ======================================================================== MSG SYSTEM ========================================================================= #
# ============================================================================================================================================================= #
def findColors():
	with open(colorspath) as f:
		for (color, r, g, b) in re.findall(r'(#\S+)\s*=\s*(\d+),\s*(\d+),\s*(\d+)', f.read()):
			yield (color, '\x07%02X%02X%02X' % (int(r), int(g), int(b)))
colors = dict(findColors())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def replaceText(text): return reduce(lambda t, r: t.replace(*r), colors.iteritems(), text)

# :: FUNCTIONS :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tell(users, msg, module_tag=None):
	if module_tag == None: usermsg.saytext2(users, 0, replaceText('#default%s #DimGrey| #blue:: #default%s' % (tag,msg)))
	else: usermsg.saytext2(users, 0, replaceText('#default%s #DimGrey| %s #DimGrey| #blue:: #default%s' % (tag,module_tag,msg)))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def say(users, msg): usermsg.saytext2(users, 0, replaceText('#default%s' % msg))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def centertell(userid, msg): es.centertell(userid, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def hudhint(users, msg, module_tag=None):
	if module_tag == None: usermsg.hudhint(users, 'SAM |:: %s' % msg)
	else: usermsg.hudhint(users, 'SAM | %s |:: %s' % (module_tag,msg))

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def hudhint2(users, msg): usermsg.hudhint(users, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def keyhint(users, msg): usermsg.keyhint(users, msg)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def motd(users, url, title): usermsg.motd(users, 2, title, url)

# ============================================================================================================================================================= #
# ======================================================================= LANG SYSTEM ========================================================================= #
# ============================================================================================================================================================= #
def lang_word(name): return word(name, None, getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_titles(name,tokens=None): return titles(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_base(name,tokens=None): return base(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_admins(name,tokens=None): return admins(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_groups(name,tokens=None): return groups(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_pcontrol(name,tokens=None): return pcontrol(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_manager(name,tokens=None): return manager(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_addons(name,tokens=None): return addons(name,tokens,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_addonsDesc(name): return addonsDesc(name,None,getLang())

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def lang_addon(addon, name, tokens = None):
	_addon = langlib.Strings(langDir + 'addons/%s/%s.ini' % (addon,addon))
	return _addon(name, tokens, getLang())

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getLang():
	if lang in langs: return langs[lang]
	else: return 'en'

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def remoteRCON(args, userid = None):
	if es.exists('variable', args[0]) or es.exists('command', args[0]):
		es.server.queuecmd(str(' '.join(args)))
		if not userid == None: tell(userid, lang_base('rcon_exec_cmd', {'cmd':args[0],'value':args[1]}), servertag)
		else: es.printmsg(base('rcon_exec_cmd', {'cmd':args[0],'value':args[1]}), servertag)
	else:
		if not userid == None: tell(userid, lang_base('rcon_not_cmd', {'arg':args[0]}), servertag)
		else: es.printmsg(base('rcon_not_cmd', {'arg':args[0]}), servertag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def regsay(name, cmd, block):
	unreg(name)
	es.set(name, cmd)
	if es.exists('saycommand', cmd) == 0: es.regsaycmd(cmd, block)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def regclient(name, cmd, block):
	unreg(name)
	es.set(name, cmd)
	if es.exists('clientcommand', cmd) == 0: es.regclientcmd(cmd, block)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unreg(name):
	cmd = es.ServerVar(name)
	if es.exists('saycommand', cmd) == 1: es.unregsaycmd(cmd)
	if es.exists('clientcommand', cmd) == 1: es.unregclientcmd(cmd)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def popupDelete(name):
	if popuplib.exists(name): popuplib.delete(name)
	if not name in popupCloud: popupCloud.append(name)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def getPage(index, itemCount):
	page = 1
	while itemCount <= index:
		itemCount += itemCount
		page += 1
	else: return page

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendMenu(userid, menu):
	try:
		popup = popuplib.find(menu)
		popup.send(userid)
	except:
		try:
			block = es.import_addon('sam/base/%s' % menu)
			block.modulePopup(userid)
		except: pass

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sound(target, sound, volume, attenuation): es.emitsound('player', target, sound, volume, attenuation)

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def langCMD(args):
	global lang
	if args: lang = str(''.join(args))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tittleCMD(args):
	global menutitle
	if args: menutitle = str(''.join(args))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def tagCMD(args):
	global tag
	if args: tag = str(''.join(args))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def check_ffCMD():
	userid = es.getcmduserid()
	ff     = es.ServerVar('mp_friendlyfire')
	if ff == 1: tell(userid, lang_base('sv_var_state_on', {'var':'Frindly Fire'}))
	elif ff == 0: tell(userid, lang_base('sv_var_state_off', {'var':'Frindly Fire'}))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def check_alltalkCMD():
	userid  = es.getcmduserid()
	alltalk = es.ServerVar('sv_alltalk')
	if alltalk == 1: tell(userid, lang_base('sv_var_state_on', {'var':'Alltalk'}))
	elif alltalk == 0: tell(userid, lang_base('sv_var_state_off', {'var':'Alltalk'}))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def adminsOnlineCMD():
	admins    = es.import_addon('sam/admins')
	userid    = es.getcmduserid()
	adminList = []
	for ply in playerlib.getPlayerList('#human'):
		if admins.isAdmin(ply.steamid): adminList.append(ply.name)
	if len(adminList) > 0: tell(userid, '#darkgreen%s#default.' % '#default, #darkgreen'.join(adminList), '#cyanADMINS ONLINE')
	else: tell(userid, lang_base('no_admins_online'), adminstag)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def RRCONcheckCMD(userid, args):
	if args:
		admins = es.import_addon('sam/admins')
		if admins.isAdmin(es.getplayersteamid(userid)):
			if admins.checkAccess(es.getplayersteamid(userid), 'Remote RCON'): remoteRCON(args, userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def RRCONserverCMD(args): remoteRCON(args)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_end(ev):
	es.server.insertcmd('exec sam/config.cfg')
	for popup in popupCloud: popupDelete(popup)
	if outdated == None: checkUpdate(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def es_map_start(ev):
	es.server.insertcmd('exec sam/config.cfg')
	for popup in popupCloud: popupDelete(popup)
	if outdated == None: checkUpdate()

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def checkUpdate(msg=1):
	sam = esamlib.getAddon('sam')
	try:
		global outdated
		version = sam.currentversion
		if not str(version) == str(es.ServerVar('sam_version')): outdated = version
		else: outdated = 0
	except: outdated = None
	if outdated == 0: tell('#all', lang_base('is_updated'), updatetag)
	elif outdated == None:
		if msg == 1: tell('#all', '#Red' + lang_base('no_connection'), updatetag)
	else: tell('#all', lang_base('is_outdated1', {'currentversion':'#purple%s#default' % es.ServerVar('sam_version')}) + ' ' + lang_base('is_outdated2', {'newversion':'#red%s#default' % version}) + '.', updatetag)
# ============================================================================================================================================================= #